/*******************************************************************************
 * Copyright (c) 2009 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.e4.languages.javascript.jsdi.connect;

import java.io.Serializable;
import java.util.List;
import java.util.Map;

public interface Connector {
	public Map defaultArguments();

	public String description();

	public String name();

	public interface Argument extends Serializable {
		public String description();

		public boolean isValid(String value);

		public String label();

		public boolean mustSpecify();

		public String name();

		public void setValue(String value);

		public String value();
	}

	public interface StringArgument extends Connector.Argument {
	}

	public interface IntegerArgument extends Connector.Argument {
		public int intValue();

		public boolean isValid(int intValue);

		public int max();

		public int min();

		public void setValue(int intValue);
	}

	public interface BooleanArgument extends Connector.Argument {
		public boolean booleanValue();

		public boolean isValid(String arg1);

		public void setValue(boolean booleanValue);
	}

	public interface SelectedArgument extends Connector.Argument {
		public List choices();
	}
}
