package org.eclipse.e4.languages.javascript.jsdi.rhino;

import java.util.Map;

import org.eclipse.e4.languages.javascript.debug.connect.JSONConstants;
import org.eclipse.e4.languages.javascript.jsdi.FunctionReference;

/**
 * Rhino implementation of {@link FunctionReference}
 * 
 * @since 1.0
 */
public class FunctionReferenceImpl extends ObjectReferenceImpl implements FunctionReference {

	private String functionName;

	/**
	 * Constructor
	 * 
	 * @param vm
	 * @param body
	 * @param stackFrameImpl
	 */
	public FunctionReferenceImpl(VirtualMachineImpl vm, Map body, StackFrameImpl stackFrameImpl) {
		super(vm, body, stackFrameImpl);
		this.functionName = (String) body.get(JSONConstants.NAME);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.e4.languages.javascript.jsdi.FunctionReference#functionName()
	 */
	public String functionName() {
		return functionName;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.e4.languages.javascript.rhino.jsdi.ObjectReferenceImpl#toString ()
	 */
	public String toString() {
		// TODO get function body as details
		return "Function"; //$NON-NLS-1$
	}
}
