package org.eclipse.e4.languages.javascript.jsdi.rhino.connect;

import org.eclipse.e4.languages.javascript.jsdi.connect.Connector.StringArgument;

public class HostArgument implements StringArgument {

	private static final long serialVersionUID = 3057403815318177030L;
	private String host;

	public HostArgument(String host) {
		setValue(host);
	}

	public String description() {
		return "The host to attach to";
	}

	public boolean isValid(String value) {
		return value != null;
	}

	public String label() {
		return "host";
	}

	public boolean mustSpecify() {
		return true;
	}

	public String name() {
		return "host";
	}

	public void setValue(String host) {
		if (!isValid(host))
			throw new IllegalArgumentException();
		this.host = host;
	}

	public String value() {
		return host;
	}

}
