package org.eclipse.e4.languages.javascript.jsdi.rhino.event;

import org.eclipse.e4.languages.javascript.jsdi.Location;
import org.eclipse.e4.languages.javascript.jsdi.ThreadReference;
import org.eclipse.e4.languages.javascript.jsdi.event.BreakpointEvent;
import org.eclipse.e4.languages.javascript.jsdi.request.BreakpointRequest;
import org.eclipse.e4.languages.javascript.jsdi.rhino.VirtualMachineImpl;

public class BreakpointEventImpl extends EventImpl implements BreakpointEvent {

	private final ThreadReference thread;
	private final Location location;

	public BreakpointEventImpl(VirtualMachineImpl vm, ThreadReference thread, Location location, BreakpointRequest request) {
		super(vm, request);
		this.thread = thread;
		this.location = location;
	}

	public ThreadReference thread() {
		return thread;
	}

	public Location location() {
		return location;
	}
}
